#include <windows.h>
#include "filter.h"
#define MIN_H 38
static LPRECT lpRect=NULL;
static int *show=NULL;
static int n=0;

//---------------------------------------------------------------------
//		tB^\̒`
//---------------------------------------------------------------------
FILTER_DLL filter = {
	FILTER_FLAG_DISP_FILTER|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_ALWAYS_ACTIVE|FILTER_FLAG_PRIORITY_LOWEST|FILTER_FLAG_EX_INFORMATION,
	320,38,
	"܂肽",
	NULL,NULL,NULL,
	NULL,NULL,
	NULL,NULL,NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	func_WndProc,
	NULL,NULL,
	NULL,
	NULL,
	"܂肽 version 0.01(l)",
	NULL,
	NULL,
};
BOOL isActive(HWND hwnd)
{
	WINDOWINFO wi;
	GetWindowInfo(hwnd,&wi);
	return wi.dwWindowStatus;
}
void tatami(HWND check,FILTER *fp)
{
	int i,w,h;
	FILTER *cfp;
	if(BST_CHECKED == SendMessage(check , BM_GETCHECK , 0 , 0)){ //`FbNĂ鎞̏
		for(i=0;i<n;i++){
			cfp=(FILTER *)(fp->exfunc->get_filterp(i));
			if(cfp==NULL||cfp==fp)
				continue;
			if(*(show+i)==TRUE){ //݂̃EChETCY擾
				GetWindowRect(cfp->hwnd,lpRect+i);
			}
			w=(lpRect+i)->right-(lpRect+i)->left;
			if(*(show+i)&&fp->exfunc->is_filter_window_disp(cfp)&&!isActive(cfp->hwnd)){ //܂肽
				h=MIN_H;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=FALSE;
			}
			if(!(*(show+i))&&isActive(cfp->hwnd)){ //ɖ߂
				h=(lpRect+i)->bottom-(lpRect+i)->top;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=TRUE;
			}
		}
	}
	else{ //`FbNꂽƂ̏
		for(i=0;i<n;i++){
			cfp=(FILTER *)fp->exfunc->get_filterp(i);
			if(cfp==NULL)
				continue;
			w=(lpRect+i)->right-(lpRect+i)->left;
			if(!*(show+i)){
				h=(lpRect+i)->bottom-(lpRect+i)->top;
				SetWindowPos(cfp->hwnd,NULL,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOSENDCHANGING|SWP_NOZORDER);
				*(show+i)=TRUE;
			}
		}
	}
}
//---------------------------------------------------------------------
//		tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}
int tatami_init(FILTER *fp,void *editp){
	SYS_INFO si;
	int i;
	FILTER *cfp;
	TCHAR buf[32];
	if(!(fp->exfunc->get_sys_info(editp,&si))) return FALSE;
	n=si.filter_n;
	if((show=(int *)malloc(sizeof(int)*n))==NULL) return FALSE;
	if((lpRect=(LPRECT)malloc(sizeof(RECT)*n))==NULL) return FALSE;
	for(i=0;i<n;i++){
		*(show+i)=TRUE;
		cfp=(FILTER *)fp->exfunc->get_filterp(i);
		if(cfp==NULL)
			continue;
		ZeroMemory(lpRect+i,sizeof(RECT));
		GetWindowRect(cfp->hwnd,lpRect+i);
	}
	return TRUE;
}

//---------------------------------------------------------------------
//		WndProc
//---------------------------------------------------------------------
BOOL func_WndProc( HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp )
{
	static int ini=0,error=0;
	static HWND check;
	SYS_INFO si;
	if(error==1) return FALSE;
	switch(message) {
		case WM_WINDOWPOSCHANGING:
			if(ini==0)
				break;
		case WM_COMMAND:
			if(ini==0){
				if(BST_CHECKED==SendMessage(check , BM_GETCHECK , 0 , 0)){
					ini=1;
					if(tatami_init(fp,editp)==FALSE){
						error=1;
						MessageBox(hwnd , TEXT("G[") ,TEXT("Error") , MB_OK);
						return FALSE;
					}
				}
				else
					break;
			}
			tatami(check,fp);
			break;
		case WM_FILTER_INIT:
			check=CreateWindow(
			TEXT("BUTTON") , TEXT("") ,
			WS_CHILD | WS_VISIBLE | BS_AUTOCHECKBOX | BS_LEFTTEXT ,
			0 , 0 , 314 , 16 ,
			hwnd , NULL , fp->dll_hinst , NULL
			);
			if(fp->exfunc->get_sys_info(editp,&si))
    			SendMessage(check, WM_SETFONT, (WPARAM)si.hfont, (LPARAM)true);
			SendMessage(check , BM_SETCHECK , BST_UNCHECKED , 0);
			break;
		case WM_FILTER_EXIT:
			SendMessage(check , BM_SETCHECK , BST_UNCHECKED , 0);
			tatami(check,fp);
			free(show);
			free(lpRect);
	}
	return FALSE;
}
